from typing import Any, Dict, Optional, Union

import httpx

from ...client import Client
from ...models.pool_service_get_all_servicers_response_200 import (
    PoolService_GetAllServicersResponse_200,
)
from ...models.pool_service_get_all_servicers_response_401 import (
    PoolService_GetAllServicersResponse_401,
)
from ...models.pool_service_get_all_servicers_response_404 import (
    PoolService_GetAllServicersResponse_404,
)
from ...models.pool_service_get_all_servicers_response_500 import (
    PoolService_GetAllServicersResponse_500,
)
from ...types import Response


def _get_kwargs(
    *,
    client: Client,
) -> Dict[str, Any]:
    url = "{}/api/v1/pools/all_servicers".format(client.base_url)

    headers: Dict[str, Any] = client.get_headers()

    return {
        "url": url,
        "headers": headers,
        "cookies": client.get_cookies(),
        "timeout": client.get_timeout(),
    }


def _parse_response(
    *, response: httpx.Response
) -> Optional[
    Union[
        PoolService_GetAllServicersResponse_200,
        PoolService_GetAllServicersResponse_401,
        PoolService_GetAllServicersResponse_404,
        PoolService_GetAllServicersResponse_500,
    ]
]:
    if response.status_code == 200:
        response_200 = PoolService_GetAllServicersResponse_200.from_dict(
            response.json()
        )

        return response_200
    if response.status_code == 401:
        response_401 = PoolService_GetAllServicersResponse_401.from_dict(
            response.json()
        )

        return response_401
    if response.status_code == 404:
        response_404 = PoolService_GetAllServicersResponse_404.from_dict(
            response.json()
        )

        return response_404
    if response.status_code == 500:
        response_500 = PoolService_GetAllServicersResponse_500.from_dict(
            response.json()
        )

        return response_500
    return None


def _build_response(
    *, response: httpx.Response
) -> Response[
    Union[
        PoolService_GetAllServicersResponse_200,
        PoolService_GetAllServicersResponse_401,
        PoolService_GetAllServicersResponse_404,
        PoolService_GetAllServicersResponse_500,
    ]
]:
    return Response(
        status_code=response.status_code,
        content=response.content,
        headers=response.headers,
        parsed=_parse_response(response=response),
    )


def sync_detailed(
    *,
    client: Client,
) -> Response[
    Union[
        PoolService_GetAllServicersResponse_200,
        PoolService_GetAllServicersResponse_401,
        PoolService_GetAllServicersResponse_404,
        PoolService_GetAllServicersResponse_500,
    ]
]:
    kwargs = _get_kwargs(
        client=client,
    )

    response = httpx.get(
        **kwargs,
    )

    return _build_response(response=response)


def sync(
    *,
    client: Client,
) -> Optional[
    Union[
        PoolService_GetAllServicersResponse_200,
        PoolService_GetAllServicersResponse_401,
        PoolService_GetAllServicersResponse_404,
        PoolService_GetAllServicersResponse_500,
    ]
]:
    """


    Args:

    Returns:
        Either a valid response or an unauthorized, not found or other error.
    """

    return sync_detailed(
        client=client,
    ).parsed


async def asyncio_detailed(
    *,
    client: Client,
) -> Response[
    Union[
        PoolService_GetAllServicersResponse_200,
        PoolService_GetAllServicersResponse_401,
        PoolService_GetAllServicersResponse_404,
        PoolService_GetAllServicersResponse_500,
    ]
]:
    kwargs = _get_kwargs(
        client=client,
    )

    async with httpx.AsyncClient() as _client:
        response = await _client.get(**kwargs)

    return _build_response(response=response)


async def asyncio(
    *,
    client: Client,
) -> Optional[
    Union[
        PoolService_GetAllServicersResponse_200,
        PoolService_GetAllServicersResponse_401,
        PoolService_GetAllServicersResponse_404,
        PoolService_GetAllServicersResponse_500,
    ]
]:
    """  """

    return (
        await asyncio_detailed(
            client=client,
        )
    ).parsed
