"""Convert infima data to pandas Dataframes."""

import pandas as pd

from .datetime_util import to_datetime


def to_dataframe(obj) -> pd.DataFrame:
    """Convert an infima object to a pandas DataFrame."""
    if isinstance(obj, list):
        df = pd.DataFrame([p.to_dict() for p in obj])
    else:
        df = pd.DataFrame(obj.dict())
    for date in ["issueDate", "maturityDate", "asOf"]:
        if date in df:
            df[date] = df[date].apply(to_datetime)
    return df
