from typing import Any, Dict, List, Type, TypeVar, Union

import attr

from ..models.cohort_coverage_info import CohortCoverageInfo
from ..types import UNSET, Unset

T = TypeVar("T", bound="CohortCoverage")


@attr.s(auto_attribs=True)
class CohortCoverage:
    """  """

    cohorts: Union[Unset, List[CohortCoverageInfo]] = UNSET
    additional_properties: Dict[str, Any] = attr.ib(init=False, factory=dict)

    def to_dict(self) -> Dict[str, Any]:
        cohorts: Union[Unset, List[Any]] = UNSET
        if not isinstance(self.cohorts, Unset):
            cohorts = []
            for cohorts_item_data in self.cohorts:
                cohorts_item = cohorts_item_data.to_dict()

                cohorts.append(cohorts_item)

        field_dict: Dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update({})
        if cohorts is not UNSET:
            field_dict["cohorts"] = cohorts

        return field_dict

    @classmethod
    def from_dict(cls: Type[T], src_dict: Dict[str, Any]) -> T:
        d = src_dict.copy()
        cohorts = []
        _cohorts = d.pop("cohorts", UNSET)
        for cohorts_item_data in _cohorts or []:
            cohorts_item = CohortCoverageInfo.from_dict(cohorts_item_data)

            cohorts.append(cohorts_item)

        cohort_coverage = cls(
            cohorts=cohorts,
        )

        cohort_coverage.additional_properties = d
        return cohort_coverage

    @property
    def additional_keys(self) -> List[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
