from typing import Any, Dict, List, Type, TypeVar, Union

import attr

from ..types import UNSET, Unset

T = TypeVar("T", bound="CohortCoverageInfo")


@attr.s(auto_attribs=True)
class CohortCoverageInfo:
    """  """

    coupon: Union[Unset, float] = UNSET
    name: Union[Unset, str] = UNSET
    num_pools: Union[Unset, int] = UNSET
    ticker: Union[Unset, str] = UNSET
    type: Union[Unset, str] = UNSET
    vintage: Union[Unset, int] = UNSET
    additional_properties: Dict[str, Any] = attr.ib(init=False, factory=dict)

    def to_dict(self) -> Dict[str, Any]:
        coupon = self.coupon
        name = self.name
        num_pools = self.num_pools
        ticker = self.ticker
        type = self.type
        vintage = self.vintage

        field_dict: Dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update({})
        if coupon is not UNSET:
            field_dict["coupon"] = coupon
        if name is not UNSET:
            field_dict["name"] = name
        if num_pools is not UNSET:
            field_dict["numPools"] = num_pools
        if ticker is not UNSET:
            field_dict["ticker"] = ticker
        if type is not UNSET:
            field_dict["type"] = type
        if vintage is not UNSET:
            field_dict["vintage"] = vintage

        return field_dict

    @classmethod
    def from_dict(cls: Type[T], src_dict: Dict[str, Any]) -> T:
        d = src_dict.copy()
        coupon = d.pop("coupon", UNSET)

        name = d.pop("name", UNSET)

        num_pools = d.pop("numPools", UNSET)

        ticker = d.pop("ticker", UNSET)

        type = d.pop("type", UNSET)

        vintage = d.pop("vintage", UNSET)

        cohort_coverage_info = cls(
            coupon=coupon,
            name=name,
            num_pools=num_pools,
            ticker=ticker,
            type=type,
            vintage=vintage,
        )

        cohort_coverage_info.additional_properties = d
        return cohort_coverage_info

    @property
    def additional_keys(self) -> List[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
