from typing import Any, Dict, List, Type, TypeVar, Union, cast

import attr

from ..models.pool_service_get_historical_prepayments_json_body_convention import (
    PoolService_GetHistoricalPrepaymentsJsonBodyConvention,
)
from ..models.pool_service_get_historical_prepayments_json_body_period import (
    PoolService_GetHistoricalPrepaymentsJsonBodyPeriod,
)
from ..types import UNSET, Unset

T = TypeVar("T", bound="GetHistoricalPrepaymentsRequest")


@attr.s(auto_attribs=True)
class GetHistoricalPrepaymentsRequest:
    """  """

    convention: Union[
        Unset, PoolService_GetHistoricalPrepaymentsJsonBodyConvention
    ] = PoolService_GetHistoricalPrepaymentsJsonBodyConvention.PERIOD
    cusips: Union[Unset, List[str]] = UNSET
    num_months: Union[Unset, int] = UNSET
    period: Union[PoolService_GetHistoricalPrepaymentsJsonBodyPeriod, Unset] = UNSET
    additional_properties: Dict[str, Any] = attr.ib(init=False, factory=dict)

    def to_dict(self) -> Dict[str, Any]:
        convention: Union[
            Unset, PoolService_GetHistoricalPrepaymentsJsonBodyConvention
        ] = UNSET
        if not isinstance(self.convention, Unset):
            convention = self.convention

        cusips: Union[Unset, List[Any]] = UNSET
        if not isinstance(self.cusips, Unset):
            cusips = self.cusips

        num_months = self.num_months
        period: Union[Unset, Dict[str, Any]] = UNSET
        if not isinstance(self.period, Unset):
            period = self.period.to_dict()

        field_dict: Dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update({})
        if convention is not UNSET:
            field_dict["convention"] = convention
        if cusips is not UNSET:
            field_dict["cusips"] = cusips
        if num_months is not UNSET:
            field_dict["numMonths"] = num_months
        if period is not UNSET:
            field_dict["period"] = period

        return field_dict

    @classmethod
    def from_dict(cls: Type[T], src_dict: Dict[str, Any]) -> T:
        d = src_dict.copy()
        convention = None
        _convention = d.pop("convention", UNSET)
        if _convention is not None and _convention is not UNSET:
            convention = PoolService_GetHistoricalPrepaymentsJsonBodyConvention(
                _convention
            )

        cusips = cast(List[str], d.pop("cusips", UNSET))

        num_months = d.pop("numMonths", UNSET)

        period: Union[PoolService_GetHistoricalPrepaymentsJsonBodyPeriod, Unset] = UNSET
        _period = d.pop("period", UNSET)
        if not isinstance(_period, Unset):
            period = PoolService_GetHistoricalPrepaymentsJsonBodyPeriod.from_dict(
                cast(Dict[str, Any], _period)
            )

        get_historical_prepayments_request = cls(
            convention=convention,
            cusips=cusips,
            num_months=num_months,
            period=period,
        )

        get_historical_prepayments_request.additional_properties = d
        return get_historical_prepayments_request

    @property
    def additional_keys(self) -> List[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
