from typing import Any, Dict, List, Type, TypeVar, Union, cast

import attr

from ..models.pool_service_get_characteristics_json_body_date import (
    PoolService_GetCharacteristicsJsonBodyDate,
)
from ..types import UNSET, Unset

T = TypeVar("T", bound="GetPoolCharasteristicsRequest")


@attr.s(auto_attribs=True)
class GetPoolCharasteristicsRequest:
    """  """

    cusips: Union[Unset, List[str]] = UNSET
    date: Union[PoolService_GetCharacteristicsJsonBodyDate, Unset] = UNSET
    additional_properties: Dict[str, Any] = attr.ib(init=False, factory=dict)

    def to_dict(self) -> Dict[str, Any]:
        cusips: Union[Unset, List[Any]] = UNSET
        if not isinstance(self.cusips, Unset):
            cusips = self.cusips

        date: Union[Unset, Dict[str, Any]] = UNSET
        if not isinstance(self.date, Unset):
            date = self.date.to_dict()

        field_dict: Dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update({})
        if cusips is not UNSET:
            field_dict["cusips"] = cusips
        if date is not UNSET:
            field_dict["date"] = date

        return field_dict

    @classmethod
    def from_dict(cls: Type[T], src_dict: Dict[str, Any]) -> T:
        d = src_dict.copy()
        cusips = cast(List[str], d.pop("cusips", UNSET))

        date: Union[PoolService_GetCharacteristicsJsonBodyDate, Unset] = UNSET
        _date = d.pop("date", UNSET)
        if not isinstance(_date, Unset):
            date = PoolService_GetCharacteristicsJsonBodyDate.from_dict(
                cast(Dict[str, Any], _date)
            )

        get_pool_charasteristics_request = cls(
            cusips=cusips,
            date=date,
        )

        get_pool_charasteristics_request.additional_properties = d
        return get_pool_charasteristics_request

    @property
    def additional_keys(self) -> List[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
