from typing import Any, Dict, List, Type, TypeVar, Union

import attr

from ..models.cohort_service_get_pool_associations_response_404_details_item import (
    CohortService_GetPoolAssociationsResponse_404DetailsItem,
)
from ..types import UNSET, Unset

T = TypeVar("T", bound="PoolAssociationsNotFound")


@attr.s(auto_attribs=True)
class PoolAssociationsNotFound:
    """  """

    code: Union[Unset, int] = UNSET
    details: Union[
        Unset, List[CohortService_GetPoolAssociationsResponse_404DetailsItem]
    ] = UNSET
    message: Union[Unset, str] = UNSET
    additional_properties: Dict[str, Any] = attr.ib(init=False, factory=dict)

    def to_dict(self) -> Dict[str, Any]:
        code = self.code
        details: Union[Unset, List[Any]] = UNSET
        if not isinstance(self.details, Unset):
            details = []
            for details_item_data in self.details:
                details_item = details_item_data.to_dict()

                details.append(details_item)

        message = self.message

        field_dict: Dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update({})
        if code is not UNSET:
            field_dict["code"] = code
        if details is not UNSET:
            field_dict["details"] = details
        if message is not UNSET:
            field_dict["message"] = message

        return field_dict

    @classmethod
    def from_dict(cls: Type[T], src_dict: Dict[str, Any]) -> T:
        d = src_dict.copy()
        code = d.pop("code", UNSET)

        details = []
        _details = d.pop("details", UNSET)
        for details_item_data in _details or []:
            details_item = (
                CohortService_GetPoolAssociationsResponse_404DetailsItem.from_dict(
                    details_item_data
                )
            )

            details.append(details_item)

        message = d.pop("message", UNSET)

        pool_associations_not_found = cls(
            code=code,
            details=details,
            message=message,
        )

        pool_associations_not_found.additional_properties = d
        return pool_associations_not_found

    @property
    def additional_keys(self) -> List[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
