from typing import Any, Dict, List, Type, TypeVar, Union

import attr

from ..models.pool_service_get_distributions_response_200_distributions_item import (
    PoolService_GetDistributionsResponse_200DistributionsItem,
)
from ..types import UNSET, Unset

T = TypeVar("T", bound="PoolDistributions")


@attr.s(auto_attribs=True)
class PoolDistributions:
    """  """

    distributions: Union[
        Unset, List[PoolService_GetDistributionsResponse_200DistributionsItem]
    ] = UNSET
    additional_properties: Dict[str, Any] = attr.ib(init=False, factory=dict)

    def to_dict(self) -> Dict[str, Any]:
        distributions: Union[Unset, List[Any]] = UNSET
        if not isinstance(self.distributions, Unset):
            distributions = []
            for distributions_item_data in self.distributions:
                distributions_item = distributions_item_data.to_dict()

                distributions.append(distributions_item)

        field_dict: Dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update({})
        if distributions is not UNSET:
            field_dict["distributions"] = distributions

        return field_dict

    @classmethod
    def from_dict(cls: Type[T], src_dict: Dict[str, Any]) -> T:
        d = src_dict.copy()
        distributions = []
        _distributions = d.pop("distributions", UNSET)
        for distributions_item_data in _distributions or []:
            distributions_item = (
                PoolService_GetDistributionsResponse_200DistributionsItem.from_dict(
                    distributions_item_data
                )
            )

            distributions.append(distributions_item)

        pool_distributions = cls(
            distributions=distributions,
        )

        pool_distributions.additional_properties = d
        return pool_distributions

    @property
    def additional_keys(self) -> List[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
