from typing import Any, Dict, List, Type, TypeVar, Union

import attr

from ..models.pool_service_get_geolocations_response_200_geos_item import (
    PoolService_GetGeolocationsResponse_200GeosItem,
)
from ..types import UNSET, Unset

T = TypeVar("T", bound="PoolGeoLocations")


@attr.s(auto_attribs=True)
class PoolGeoLocations:
    """  """

    geos: Union[Unset, List[PoolService_GetGeolocationsResponse_200GeosItem]] = UNSET
    additional_properties: Dict[str, Any] = attr.ib(init=False, factory=dict)

    def to_dict(self) -> Dict[str, Any]:
        geos: Union[Unset, List[Any]] = UNSET
        if not isinstance(self.geos, Unset):
            geos = []
            for geos_item_data in self.geos:
                geos_item = geos_item_data.to_dict()

                geos.append(geos_item)

        field_dict: Dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update({})
        if geos is not UNSET:
            field_dict["geos"] = geos

        return field_dict

    @classmethod
    def from_dict(cls: Type[T], src_dict: Dict[str, Any]) -> T:
        d = src_dict.copy()
        geos = []
        _geos = d.pop("geos", UNSET)
        for geos_item_data in _geos or []:
            geos_item = PoolService_GetGeolocationsResponse_200GeosItem.from_dict(
                geos_item_data
            )

            geos.append(geos_item)

        pool_geo_locations = cls(
            geos=geos,
        )

        pool_geo_locations.additional_properties = d
        return pool_geo_locations

    @property
    def additional_keys(self) -> List[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
