from typing import Any, Dict, List, Type, TypeVar, Union, cast

import attr

from ..models.pool_match_issue_date import PoolMatchIssueDate
from ..models.pool_match_maturity_date import PoolMatchMaturityDate
from ..models.search_service_search_response_200_pools_ite_n_m_a_r_m_c_d_f_n_m_a_r_m138 import (
    SearchService_SearchResponse_200PoolsIteNMARMCDFNMARM138,
)
from ..models.search_service_search_response_200_pools_item_agency import (
    SearchService_SearchResponse_200PoolsItemAgency,
)
from ..models.search_service_search_response_200_pools_item_agency_ticker import (
    SearchService_SearchResponse_200PoolsItemAgencyTicker,
)
from ..models.search_service_search_response_200_pools_item_coupon_type import (
    SearchService_SearchResponse_200PoolsItemCouponType,
)
from ..types import UNSET, Unset

T = TypeVar("T", bound="PoolMatch")


@attr.s(auto_attribs=True)
class PoolMatch:
    """ Pool attributes. """

    agency: Union[
        Unset, SearchService_SearchResponse_200PoolsItemAgency
    ] = SearchService_SearchResponse_200PoolsItemAgency.NULL_AGENCY
    agency_ticker: Union[
        Unset, SearchService_SearchResponse_200PoolsItemAgencyTicker
    ] = SearchService_SearchResponse_200PoolsItemAgencyTicker.NULL_AGENCY_TICKER
    coupon: Union[Unset, float] = UNSET
    coupon_type: Union[
        Unset, SearchService_SearchResponse_200PoolsItemCouponType
    ] = SearchService_SearchResponse_200PoolsItemCouponType.NULL_COUPON_TYPE
    cusip: Union[Unset, str] = UNSET
    factor: Union[Unset, float] = UNSET
    iss_num_loans: Union[Unset, int] = UNSET
    iss_upb: Union[Unset, float] = UNSET
    iss_wac: Union[Unset, float] = UNSET
    iss_wala: Union[Unset, int] = UNSET
    issue_date: Union[PoolMatchIssueDate, Unset] = UNSET
    maturity_date: Union[PoolMatchMaturityDate, Unset] = UNSET
    max_cs: Union[Unset, int] = UNSET
    max_ltv: Union[Unset, int] = UNSET
    max_ols: Union[Unset, float] = UNSET
    max_state: Union[Unset, str] = UNSET
    max_state_pct: Union[Unset, float] = UNSET
    min_cs: Union[Unset, int] = UNSET
    min_ltv: Union[Unset, int] = UNSET
    min_ols: Union[Unset, float] = UNSET
    num_loans: Union[Unset, int] = UNSET
    pool_number: Union[Unset, str] = UNSET
    prefix: Union[Unset, str] = UNSET
    product: Union[
        Unset, SearchService_SearchResponse_200PoolsIteNMARMCDFNMARM138
    ] = SearchService_SearchResponse_200PoolsIteNMARMCDFNMARM138.NULL_PRODUCT
    production_year: Union[Unset, int] = UNSET
    purch_pct: Union[Unset, float] = UNSET
    refi_pct: Union[Unset, float] = UNSET
    upb: Union[Unset, float] = UNSET
    wac: Union[Unset, float] = UNSET
    wala: Union[Unset, float] = UNSET
    wam: Union[Unset, float] = UNSET
    waocs: Union[Unset, int] = UNSET
    waols: Union[Unset, float] = UNSET
    waoltv: Union[Unset, int] = UNSET
    additional_properties: Dict[str, Any] = attr.ib(init=False, factory=dict)

    def to_dict(self) -> Dict[str, Any]:
        agency: Union[Unset, SearchService_SearchResponse_200PoolsItemAgency] = UNSET
        if not isinstance(self.agency, Unset):
            agency = self.agency

        agency_ticker: Union[
            Unset, SearchService_SearchResponse_200PoolsItemAgencyTicker
        ] = UNSET
        if not isinstance(self.agency_ticker, Unset):
            agency_ticker = self.agency_ticker

        coupon = self.coupon
        coupon_type: Union[
            Unset, SearchService_SearchResponse_200PoolsItemCouponType
        ] = UNSET
        if not isinstance(self.coupon_type, Unset):
            coupon_type = self.coupon_type

        cusip = self.cusip
        factor = self.factor
        iss_num_loans = self.iss_num_loans
        iss_upb = self.iss_upb
        iss_wac = self.iss_wac
        iss_wala = self.iss_wala
        issue_date: Union[Unset, Dict[str, Any]] = UNSET
        if not isinstance(self.issue_date, Unset):
            issue_date = self.issue_date.to_dict()

        maturity_date: Union[Unset, Dict[str, Any]] = UNSET
        if not isinstance(self.maturity_date, Unset):
            maturity_date = self.maturity_date.to_dict()

        max_cs = self.max_cs
        max_ltv = self.max_ltv
        max_ols = self.max_ols
        max_state = self.max_state
        max_state_pct = self.max_state_pct
        min_cs = self.min_cs
        min_ltv = self.min_ltv
        min_ols = self.min_ols
        num_loans = self.num_loans
        pool_number = self.pool_number
        prefix = self.prefix
        product: Union[
            Unset, SearchService_SearchResponse_200PoolsIteNMARMCDFNMARM138
        ] = UNSET
        if not isinstance(self.product, Unset):
            product = self.product

        production_year = self.production_year
        purch_pct = self.purch_pct
        refi_pct = self.refi_pct
        upb = self.upb
        wac = self.wac
        wala = self.wala
        wam = self.wam
        waocs = self.waocs
        waols = self.waols
        waoltv = self.waoltv

        field_dict: Dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update({})
        if agency is not UNSET:
            field_dict["agency"] = agency
        if agency_ticker is not UNSET:
            field_dict["agencyTicker"] = agency_ticker
        if coupon is not UNSET:
            field_dict["coupon"] = coupon
        if coupon_type is not UNSET:
            field_dict["couponType"] = coupon_type
        if cusip is not UNSET:
            field_dict["cusip"] = cusip
        if factor is not UNSET:
            field_dict["factor"] = factor
        if iss_num_loans is not UNSET:
            field_dict["issNumLoans"] = iss_num_loans
        if iss_upb is not UNSET:
            field_dict["issUpb"] = iss_upb
        if iss_wac is not UNSET:
            field_dict["issWac"] = iss_wac
        if iss_wala is not UNSET:
            field_dict["issWala"] = iss_wala
        if issue_date is not UNSET:
            field_dict["issueDate"] = issue_date
        if maturity_date is not UNSET:
            field_dict["maturityDate"] = maturity_date
        if max_cs is not UNSET:
            field_dict["maxCs"] = max_cs
        if max_ltv is not UNSET:
            field_dict["maxLtv"] = max_ltv
        if max_ols is not UNSET:
            field_dict["maxOls"] = max_ols
        if max_state is not UNSET:
            field_dict["maxState"] = max_state
        if max_state_pct is not UNSET:
            field_dict["maxStatePct"] = max_state_pct
        if min_cs is not UNSET:
            field_dict["minCs"] = min_cs
        if min_ltv is not UNSET:
            field_dict["minLtv"] = min_ltv
        if min_ols is not UNSET:
            field_dict["minOls"] = min_ols
        if num_loans is not UNSET:
            field_dict["numLoans"] = num_loans
        if pool_number is not UNSET:
            field_dict["poolNumber"] = pool_number
        if prefix is not UNSET:
            field_dict["prefix"] = prefix
        if product is not UNSET:
            field_dict["product"] = product
        if production_year is not UNSET:
            field_dict["productionYear"] = production_year
        if purch_pct is not UNSET:
            field_dict["purchPct"] = purch_pct
        if refi_pct is not UNSET:
            field_dict["refiPct"] = refi_pct
        if upb is not UNSET:
            field_dict["upb"] = upb
        if wac is not UNSET:
            field_dict["wac"] = wac
        if wala is not UNSET:
            field_dict["wala"] = wala
        if wam is not UNSET:
            field_dict["wam"] = wam
        if waocs is not UNSET:
            field_dict["waocs"] = waocs
        if waols is not UNSET:
            field_dict["waols"] = waols
        if waoltv is not UNSET:
            field_dict["waoltv"] = waoltv

        return field_dict

    @classmethod
    def from_dict(cls: Type[T], src_dict: Dict[str, Any]) -> T:
        d = src_dict.copy()
        agency = None
        _agency = d.pop("agency", UNSET)
        if _agency is not None and _agency is not UNSET:
            agency = SearchService_SearchResponse_200PoolsItemAgency(_agency)

        agency_ticker = None
        _agency_ticker = d.pop("agencyTicker", UNSET)
        if _agency_ticker is not None and _agency_ticker is not UNSET:
            agency_ticker = SearchService_SearchResponse_200PoolsItemAgencyTicker(
                _agency_ticker
            )

        coupon = d.pop("coupon", UNSET)

        coupon_type = None
        _coupon_type = d.pop("couponType", UNSET)
        if _coupon_type is not None and _coupon_type is not UNSET:
            coupon_type = SearchService_SearchResponse_200PoolsItemCouponType(
                _coupon_type
            )

        cusip = d.pop("cusip", UNSET)

        factor = d.pop("factor", UNSET)

        iss_num_loans = d.pop("issNumLoans", UNSET)

        iss_upb = d.pop("issUpb", UNSET)

        iss_wac = d.pop("issWac", UNSET)

        iss_wala = d.pop("issWala", UNSET)

        issue_date: Union[PoolMatchIssueDate, Unset] = UNSET
        _issue_date = d.pop("issueDate", UNSET)
        if not isinstance(_issue_date, Unset):
            issue_date = PoolMatchIssueDate.from_dict(cast(Dict[str, Any], _issue_date))

        maturity_date: Union[PoolMatchMaturityDate, Unset] = UNSET
        _maturity_date = d.pop("maturityDate", UNSET)
        if not isinstance(_maturity_date, Unset):
            maturity_date = PoolMatchMaturityDate.from_dict(
                cast(Dict[str, Any], _maturity_date)
            )

        max_cs = d.pop("maxCs", UNSET)

        max_ltv = d.pop("maxLtv", UNSET)

        max_ols = d.pop("maxOls", UNSET)

        max_state = d.pop("maxState", UNSET)

        max_state_pct = d.pop("maxStatePct", UNSET)

        min_cs = d.pop("minCs", UNSET)

        min_ltv = d.pop("minLtv", UNSET)

        min_ols = d.pop("minOls", UNSET)

        num_loans = d.pop("numLoans", UNSET)

        pool_number = d.pop("poolNumber", UNSET)

        prefix = d.pop("prefix", UNSET)

        product = None
        _product = d.pop("product", UNSET)
        if _product is not None and _product is not UNSET:
            product = SearchService_SearchResponse_200PoolsIteNMARMCDFNMARM138(_product)

        production_year = d.pop("productionYear", UNSET)

        purch_pct = d.pop("purchPct", UNSET)

        refi_pct = d.pop("refiPct", UNSET)

        upb = d.pop("upb", UNSET)

        wac = d.pop("wac", UNSET)

        wala = d.pop("wala", UNSET)

        wam = d.pop("wam", UNSET)

        waocs = d.pop("waocs", UNSET)

        waols = d.pop("waols", UNSET)

        waoltv = d.pop("waoltv", UNSET)

        pool_match = cls(
            agency=agency,
            agency_ticker=agency_ticker,
            coupon=coupon,
            coupon_type=coupon_type,
            cusip=cusip,
            factor=factor,
            iss_num_loans=iss_num_loans,
            iss_upb=iss_upb,
            iss_wac=iss_wac,
            iss_wala=iss_wala,
            issue_date=issue_date,
            maturity_date=maturity_date,
            max_cs=max_cs,
            max_ltv=max_ltv,
            max_ols=max_ols,
            max_state=max_state,
            max_state_pct=max_state_pct,
            min_cs=min_cs,
            min_ltv=min_ltv,
            min_ols=min_ols,
            num_loans=num_loans,
            pool_number=pool_number,
            prefix=prefix,
            product=product,
            production_year=production_year,
            purch_pct=purch_pct,
            refi_pct=refi_pct,
            upb=upb,
            wac=wac,
            wala=wala,
            wam=wam,
            waocs=waocs,
            waols=waols,
            waoltv=waoltv,
        )

        pool_match.additional_properties = d
        return pool_match

    @property
    def additional_keys(self) -> List[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
