from typing import Any, Dict, List, Type, TypeVar, Union

import attr

from ..models.pool_service_get_quartiles_response_200_quartiles_item import (
    PoolService_GetQuartilesResponse_200QuartilesItem,
)
from ..types import UNSET, Unset

T = TypeVar("T", bound="PoolQuartiles")


@attr.s(auto_attribs=True)
class PoolQuartiles:
    """  """

    quartiles: Union[
        Unset, List[PoolService_GetQuartilesResponse_200QuartilesItem]
    ] = UNSET
    additional_properties: Dict[str, Any] = attr.ib(init=False, factory=dict)

    def to_dict(self) -> Dict[str, Any]:
        quartiles: Union[Unset, List[Any]] = UNSET
        if not isinstance(self.quartiles, Unset):
            quartiles = []
            for quartiles_item_data in self.quartiles:
                quartiles_item = quartiles_item_data.to_dict()

                quartiles.append(quartiles_item)

        field_dict: Dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update({})
        if quartiles is not UNSET:
            field_dict["quartiles"] = quartiles

        return field_dict

    @classmethod
    def from_dict(cls: Type[T], src_dict: Dict[str, Any]) -> T:
        d = src_dict.copy()
        quartiles = []
        _quartiles = d.pop("quartiles", UNSET)
        for quartiles_item_data in _quartiles or []:
            quartiles_item = (
                PoolService_GetQuartilesResponse_200QuartilesItem.from_dict(
                    quartiles_item_data
                )
            )

            quartiles.append(quartiles_item)

        pool_quartiles = cls(
            quartiles=quartiles,
        )

        pool_quartiles.additional_properties = d
        return pool_quartiles

    @property
    def additional_keys(self) -> List[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
