from typing import Any, Dict, List, Type, TypeVar, Union

import attr

from ..types import UNSET, Unset

T = TypeVar("T", bound="PoolService_GetSummariesResponse_200SummariesItemOccupancy")


@attr.s(auto_attribs=True)
class PoolService_GetSummariesResponse_200SummariesItemOccupancy:
    """ Occupancy of the loan. """

    percentage_investor: Union[Unset, float] = UNSET
    percentage_owner: Union[Unset, float] = UNSET
    percentage_second_home: Union[Unset, float] = UNSET
    additional_properties: Dict[str, Any] = attr.ib(init=False, factory=dict)

    def to_dict(self) -> Dict[str, Any]:
        percentage_investor = self.percentage_investor
        percentage_owner = self.percentage_owner
        percentage_second_home = self.percentage_second_home

        field_dict: Dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update({})
        if percentage_investor is not UNSET:
            field_dict["percentageInvestor"] = percentage_investor
        if percentage_owner is not UNSET:
            field_dict["percentageOwner"] = percentage_owner
        if percentage_second_home is not UNSET:
            field_dict["percentageSecondHome"] = percentage_second_home

        return field_dict

    @classmethod
    def from_dict(cls: Type[T], src_dict: Dict[str, Any]) -> T:
        d = src_dict.copy()
        percentage_investor = d.pop("percentageInvestor", UNSET)

        percentage_owner = d.pop("percentageOwner", UNSET)

        percentage_second_home = d.pop("percentageSecondHome", UNSET)

        pool_service_get_summaries_response_200_summaries_item_occupancy = cls(
            percentage_investor=percentage_investor,
            percentage_owner=percentage_owner,
            percentage_second_home=percentage_second_home,
        )

        pool_service_get_summaries_response_200_summaries_item_occupancy.additional_properties = (
            d
        )
        return pool_service_get_summaries_response_200_summaries_item_occupancy

    @property
    def additional_keys(self) -> List[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
