from typing import Any, Dict, List, Type, TypeVar, Union, cast

import attr

from ..models.prediction_service_get_portfolio_look_ahead_json_body_ahead import (
    PredictionService_GetPortfolioLookAheadJsonBodyAhead,
)
from ..models.prediction_service_get_portfolio_look_ahead_json_body_convention import (
    PredictionService_GetPortfolioLookAheadJsonBodyConvention,
)
from ..models.prediction_service_get_portfolio_look_ahead_json_body_from import (
    PredictionService_GetPortfolioLookAheadJsonBodyFrom,
)
from ..models.prediction_service_get_portfolio_look_ahead_json_body_scenario import (
    PredictionService_GetPortfolioLookAheadJsonBodyScenario,
)
from ..types import UNSET, Unset

T = TypeVar("T", bound="PortfolioLookAheadPredictionRequest")


@attr.s(auto_attribs=True)
class PortfolioLookAheadPredictionRequest:
    """  """

    ahead: Union[
        Unset, PredictionService_GetPortfolioLookAheadJsonBodyAhead
    ] = PredictionService_GetPortfolioLookAheadJsonBodyAhead.NONE
    convention: Union[
        Unset, PredictionService_GetPortfolioLookAheadJsonBodyConvention
    ] = PredictionService_GetPortfolioLookAheadJsonBodyConvention.PERIOD
    cusips: Union[Unset, List[str]] = UNSET
    from_: Union[PredictionService_GetPortfolioLookAheadJsonBodyFrom, Unset] = UNSET
    scenario: Union[
        Unset, PredictionService_GetPortfolioLookAheadJsonBodyScenario
    ] = PredictionService_GetPortfolioLookAheadJsonBodyScenario.BASELINE
    additional_properties: Dict[str, Any] = attr.ib(init=False, factory=dict)

    def to_dict(self) -> Dict[str, Any]:
        ahead: Union[
            Unset, PredictionService_GetPortfolioLookAheadJsonBodyAhead
        ] = UNSET
        if not isinstance(self.ahead, Unset):
            ahead = self.ahead

        convention: Union[
            Unset, PredictionService_GetPortfolioLookAheadJsonBodyConvention
        ] = UNSET
        if not isinstance(self.convention, Unset):
            convention = self.convention

        cusips: Union[Unset, List[Any]] = UNSET
        if not isinstance(self.cusips, Unset):
            cusips = self.cusips

        from_: Union[Unset, Dict[str, Any]] = UNSET
        if not isinstance(self.from_, Unset):
            from_ = self.from_.to_dict()

        scenario: Union[
            Unset, PredictionService_GetPortfolioLookAheadJsonBodyScenario
        ] = UNSET
        if not isinstance(self.scenario, Unset):
            scenario = self.scenario

        field_dict: Dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update({})
        if ahead is not UNSET:
            field_dict["ahead"] = ahead
        if convention is not UNSET:
            field_dict["convention"] = convention
        if cusips is not UNSET:
            field_dict["cusips"] = cusips
        if from_ is not UNSET:
            field_dict["from"] = from_
        if scenario is not UNSET:
            field_dict["scenario"] = scenario

        return field_dict

    @classmethod
    def from_dict(cls: Type[T], src_dict: Dict[str, Any]) -> T:
        d = src_dict.copy()
        ahead = None
        _ahead = d.pop("ahead", UNSET)
        if _ahead is not None and _ahead is not UNSET:
            ahead = PredictionService_GetPortfolioLookAheadJsonBodyAhead(_ahead)

        convention = None
        _convention = d.pop("convention", UNSET)
        if _convention is not None and _convention is not UNSET:
            convention = PredictionService_GetPortfolioLookAheadJsonBodyConvention(
                _convention
            )

        cusips = cast(List[str], d.pop("cusips", UNSET))

        from_: Union[PredictionService_GetPortfolioLookAheadJsonBodyFrom, Unset] = UNSET
        _from_ = d.pop("from", UNSET)
        if not isinstance(_from_, Unset):
            from_ = PredictionService_GetPortfolioLookAheadJsonBodyFrom.from_dict(
                cast(Dict[str, Any], _from_)
            )

        scenario = None
        _scenario = d.pop("scenario", UNSET)
        if _scenario is not None and _scenario is not UNSET:
            scenario = PredictionService_GetPortfolioLookAheadJsonBodyScenario(
                _scenario
            )

        portfolio_look_ahead_prediction_request = cls(
            ahead=ahead,
            convention=convention,
            cusips=cusips,
            from_=from_,
            scenario=scenario,
        )

        portfolio_look_ahead_prediction_request.additional_properties = d
        return portfolio_look_ahead_prediction_request

    @property
    def additional_keys(self) -> List[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
