from typing import Any, Dict, List, Type, TypeVar, Union, cast

import attr

from ..models.prediction_service_get_portfolio_response_200_predictions_item_values_item_ahead import (
    PredictionService_GetPortfolioResponse_200PredictionsItemValuesItemAhead,
)
from ..models.prediction_service_get_portfolio_response_200_predictions_item_values_item_period import (
    PredictionService_GetPortfolioResponse_200PredictionsItemValuesItemPeriod,
)
from ..types import UNSET, Unset

T = TypeVar(
    "T", bound="PredictionService_GetPortfolioResponse_200PredictionsItemValuesItem"
)


@attr.s(auto_attribs=True)
class PredictionService_GetPortfolioResponse_200PredictionsItemValuesItem:
    """  """

    ahead: Union[
        Unset, PredictionService_GetPortfolioResponse_200PredictionsItemValuesItemAhead
    ] = PredictionService_GetPortfolioResponse_200PredictionsItemValuesItemAhead.NONE
    cpr: Union[Unset, float] = UNSET
    cpr_high: Union[Unset, float] = UNSET
    cpr_low: Union[Unset, float] = UNSET
    period: Union[
        PredictionService_GetPortfolioResponse_200PredictionsItemValuesItemPeriod, Unset
    ] = UNSET
    smm: Union[Unset, float] = UNSET
    smm_high: Union[Unset, float] = UNSET
    smm_low: Union[Unset, float] = UNSET
    additional_properties: Dict[str, Any] = attr.ib(init=False, factory=dict)

    def to_dict(self) -> Dict[str, Any]:
        ahead: Union[
            Unset,
            PredictionService_GetPortfolioResponse_200PredictionsItemValuesItemAhead,
        ] = UNSET
        if not isinstance(self.ahead, Unset):
            ahead = self.ahead

        cpr = self.cpr
        cpr_high = self.cpr_high
        cpr_low = self.cpr_low
        period: Union[Unset, Dict[str, Any]] = UNSET
        if not isinstance(self.period, Unset):
            period = self.period.to_dict()

        smm = self.smm
        smm_high = self.smm_high
        smm_low = self.smm_low

        field_dict: Dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update({})
        if ahead is not UNSET:
            field_dict["ahead"] = ahead
        if cpr is not UNSET:
            field_dict["cpr"] = cpr
        if cpr_high is not UNSET:
            field_dict["cprHigh"] = cpr_high
        if cpr_low is not UNSET:
            field_dict["cprLow"] = cpr_low
        if period is not UNSET:
            field_dict["period"] = period
        if smm is not UNSET:
            field_dict["smm"] = smm
        if smm_high is not UNSET:
            field_dict["smmHigh"] = smm_high
        if smm_low is not UNSET:
            field_dict["smmLow"] = smm_low

        return field_dict

    @classmethod
    def from_dict(cls: Type[T], src_dict: Dict[str, Any]) -> T:
        d = src_dict.copy()
        ahead = None
        _ahead = d.pop("ahead", UNSET)
        if _ahead is not None and _ahead is not UNSET:
            ahead = PredictionService_GetPortfolioResponse_200PredictionsItemValuesItemAhead(
                _ahead
            )

        cpr = d.pop("cpr", UNSET)

        cpr_high = d.pop("cprHigh", UNSET)

        cpr_low = d.pop("cprLow", UNSET)

        period: Union[
            PredictionService_GetPortfolioResponse_200PredictionsItemValuesItemPeriod,
            Unset,
        ] = UNSET
        _period = d.pop("period", UNSET)
        if not isinstance(_period, Unset):
            period = PredictionService_GetPortfolioResponse_200PredictionsItemValuesItemPeriod.from_dict(
                cast(Dict[str, Any], _period)
            )

        smm = d.pop("smm", UNSET)

        smm_high = d.pop("smmHigh", UNSET)

        smm_low = d.pop("smmLow", UNSET)

        prediction_service_get_portfolio_response_200_predictions_item_values_item = (
            cls(
                ahead=ahead,
                cpr=cpr,
                cpr_high=cpr_high,
                cpr_low=cpr_low,
                period=period,
                smm=smm,
                smm_high=smm_high,
                smm_low=smm_low,
            )
        )

        prediction_service_get_portfolio_response_200_predictions_item_values_item.additional_properties = (
            d
        )
        return (
            prediction_service_get_portfolio_response_200_predictions_item_values_item
        )

    @property
    def additional_keys(self) -> List[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
