from typing import Any, Dict, List, Type, TypeVar, Union, cast

import attr

from ..models.search_service_search_json_body_attributes import (
    SearchService_SearchJsonBodyAttributes,
)
from ..models.search_service_search_json_body_cohorts import (
    SearchService_SearchJsonBodyCohorts,
)
from ..models.search_service_search_json_body_criteria import (
    SearchService_SearchJsonBodyCriteria,
)
from ..types import UNSET, Unset

T = TypeVar("T", bound="SearchService_SearchJsonBody")


@attr.s(auto_attribs=True)
class SearchService_SearchJsonBody:
    """  """

    attributes: Union[SearchService_SearchJsonBodyAttributes, Unset] = UNSET
    cohorts: Union[SearchService_SearchJsonBodyCohorts, Unset] = UNSET
    criteria: Union[SearchService_SearchJsonBodyCriteria, Unset] = UNSET
    additional_properties: Dict[str, Any] = attr.ib(init=False, factory=dict)

    def to_dict(self) -> Dict[str, Any]:
        attributes: Union[Unset, Dict[str, Any]] = UNSET
        if not isinstance(self.attributes, Unset):
            attributes = self.attributes.to_dict()

        cohorts: Union[Unset, Dict[str, Any]] = UNSET
        if not isinstance(self.cohorts, Unset):
            cohorts = self.cohorts.to_dict()

        criteria: Union[Unset, Dict[str, Any]] = UNSET
        if not isinstance(self.criteria, Unset):
            criteria = self.criteria.to_dict()

        field_dict: Dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update({})
        if attributes is not UNSET:
            field_dict["attributes"] = attributes
        if cohorts is not UNSET:
            field_dict["cohorts"] = cohorts
        if criteria is not UNSET:
            field_dict["criteria"] = criteria

        return field_dict

    @classmethod
    def from_dict(cls: Type[T], src_dict: Dict[str, Any]) -> T:
        d = src_dict.copy()
        attributes: Union[SearchService_SearchJsonBodyAttributes, Unset] = UNSET
        _attributes = d.pop("attributes", UNSET)
        if not isinstance(_attributes, Unset):
            attributes = SearchService_SearchJsonBodyAttributes.from_dict(
                cast(Dict[str, Any], _attributes)
            )

        cohorts: Union[SearchService_SearchJsonBodyCohorts, Unset] = UNSET
        _cohorts = d.pop("cohorts", UNSET)
        if not isinstance(_cohorts, Unset):
            cohorts = SearchService_SearchJsonBodyCohorts.from_dict(
                cast(Dict[str, Any], _cohorts)
            )

        criteria: Union[SearchService_SearchJsonBodyCriteria, Unset] = UNSET
        _criteria = d.pop("criteria", UNSET)
        if not isinstance(_criteria, Unset):
            criteria = SearchService_SearchJsonBodyCriteria.from_dict(
                cast(Dict[str, Any], _criteria)
            )

        search_service_search_json_body = cls(
            attributes=attributes,
            cohorts=cohorts,
            criteria=criteria,
        )

        search_service_search_json_body.additional_properties = d
        return search_service_search_json_body

    @property
    def additional_keys(self) -> List[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
