from typing import Any, Dict, List, Type, TypeVar, Union, cast

import attr

from ..models.search_service_search_json_body_attributes_maturity_date_range_end import (
    SearchService_SearchJsonBodyAttributesMaturityDateRangeEnd,
)
from ..models.search_service_search_json_body_attributes_maturity_date_range_start import (
    SearchService_SearchJsonBodyAttributesMaturityDateRangeStart,
)
from ..types import UNSET, Unset

T = TypeVar("T", bound="SearchService_SearchJsonBodyAttributesMaturityDateRange")


@attr.s(auto_attribs=True)
class SearchService_SearchJsonBodyAttributesMaturityDateRange:
    """  """

    end: Union[
        SearchService_SearchJsonBodyAttributesMaturityDateRangeEnd, Unset
    ] = UNSET
    start: Union[
        SearchService_SearchJsonBodyAttributesMaturityDateRangeStart, Unset
    ] = UNSET
    additional_properties: Dict[str, Any] = attr.ib(init=False, factory=dict)

    def to_dict(self) -> Dict[str, Any]:
        end: Union[Unset, Dict[str, Any]] = UNSET
        if not isinstance(self.end, Unset):
            end = self.end.to_dict()

        start: Union[Unset, Dict[str, Any]] = UNSET
        if not isinstance(self.start, Unset):
            start = self.start.to_dict()

        field_dict: Dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update({})
        if end is not UNSET:
            field_dict["end"] = end
        if start is not UNSET:
            field_dict["start"] = start

        return field_dict

    @classmethod
    def from_dict(cls: Type[T], src_dict: Dict[str, Any]) -> T:
        d = src_dict.copy()
        end: Union[
            SearchService_SearchJsonBodyAttributesMaturityDateRangeEnd, Unset
        ] = UNSET
        _end = d.pop("end", UNSET)
        if not isinstance(_end, Unset):
            end = SearchService_SearchJsonBodyAttributesMaturityDateRangeEnd.from_dict(
                cast(Dict[str, Any], _end)
            )

        start: Union[
            SearchService_SearchJsonBodyAttributesMaturityDateRangeStart, Unset
        ] = UNSET
        _start = d.pop("start", UNSET)
        if not isinstance(_start, Unset):
            start = (
                SearchService_SearchJsonBodyAttributesMaturityDateRangeStart.from_dict(
                    cast(Dict[str, Any], _start)
                )
            )

        search_service_search_json_body_attributes_maturity_date_range = cls(
            end=end,
            start=start,
        )

        search_service_search_json_body_attributes_maturity_date_range.additional_properties = (
            d
        )
        return search_service_search_json_body_attributes_maturity_date_range

    @property
    def additional_keys(self) -> List[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
