from typing import Any, Dict, List, Type, TypeVar, Union

import attr

from ..types import UNSET, Unset

T = TypeVar("T", bound="SearchService_SearchJsonBodyAttributesWacRange")


@attr.s(auto_attribs=True)
class SearchService_SearchJsonBodyAttributesWacRange:
    """  """

    max: Union[Unset, float] = UNSET
    min: Union[Unset, float] = UNSET
    additional_properties: Dict[str, Any] = attr.ib(init=False, factory=dict)

    def to_dict(self) -> Dict[str, Any]:
        max = self.max
        min = self.min

        field_dict: Dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update({})
        if max is not UNSET:
            field_dict["max"] = max
        if min is not UNSET:
            field_dict["min"] = min

        return field_dict

    @classmethod
    def from_dict(cls: Type[T], src_dict: Dict[str, Any]) -> T:
        d = src_dict.copy()
        max = d.pop("max", UNSET)

        min = d.pop("min", UNSET)

        search_service_search_json_body_attributes_wac_range = cls(
            max=max,
            min=min,
        )

        search_service_search_json_body_attributes_wac_range.additional_properties = d
        return search_service_search_json_body_attributes_wac_range

    @property
    def additional_keys(self) -> List[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
