from typing import Any, Dict, List, Type, TypeVar, Union, cast

import attr

from ..models.search_service_search_json_body_criteria_geo import (
    SearchService_SearchJsonBodyCriteriaGeo,
)
from ..models.search_service_search_json_body_criteria_servicer import (
    SearchService_SearchJsonBodyCriteriaServicer,
)
from ..types import UNSET, Unset

T = TypeVar("T", bound="SearchService_SearchJsonBodyCriteria")


@attr.s(auto_attribs=True)
class SearchService_SearchJsonBodyCriteria:
    """  """

    geo: Union[SearchService_SearchJsonBodyCriteriaGeo, Unset] = UNSET
    servicer: Union[SearchService_SearchJsonBodyCriteriaServicer, Unset] = UNSET
    additional_properties: Dict[str, Any] = attr.ib(init=False, factory=dict)

    def to_dict(self) -> Dict[str, Any]:
        geo: Union[Unset, Dict[str, Any]] = UNSET
        if not isinstance(self.geo, Unset):
            geo = self.geo.to_dict()

        servicer: Union[Unset, Dict[str, Any]] = UNSET
        if not isinstance(self.servicer, Unset):
            servicer = self.servicer.to_dict()

        field_dict: Dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update({})
        if geo is not UNSET:
            field_dict["geo"] = geo
        if servicer is not UNSET:
            field_dict["servicer"] = servicer

        return field_dict

    @classmethod
    def from_dict(cls: Type[T], src_dict: Dict[str, Any]) -> T:
        d = src_dict.copy()
        geo: Union[SearchService_SearchJsonBodyCriteriaGeo, Unset] = UNSET
        _geo = d.pop("geo", UNSET)
        if not isinstance(_geo, Unset):
            geo = SearchService_SearchJsonBodyCriteriaGeo.from_dict(
                cast(Dict[str, Any], _geo)
            )

        servicer: Union[SearchService_SearchJsonBodyCriteriaServicer, Unset] = UNSET
        _servicer = d.pop("servicer", UNSET)
        if not isinstance(_servicer, Unset):
            servicer = SearchService_SearchJsonBodyCriteriaServicer.from_dict(
                cast(Dict[str, Any], _servicer)
            )

        search_service_search_json_body_criteria = cls(
            geo=geo,
            servicer=servicer,
        )

        search_service_search_json_body_criteria.additional_properties = d
        return search_service_search_json_body_criteria

    @property
    def additional_keys(self) -> List[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
