from typing import Any, Dict, List, Type, TypeVar, Union

import attr

from ..models.search_service_search_json_body_criteria_geo_excludes_item import (
    SearchService_SearchJsonBodyCriteriaGeoExcludesItem,
)
from ..models.search_service_search_json_body_criteria_geo_includes_item import (
    SearchService_SearchJsonBodyCriteriaGeoIncludesItem,
)
from ..types import UNSET, Unset

T = TypeVar("T", bound="SearchService_SearchJsonBodyCriteriaGeo")


@attr.s(auto_attribs=True)
class SearchService_SearchJsonBodyCriteriaGeo:
    """  """

    excludes: Union[
        Unset, List[SearchService_SearchJsonBodyCriteriaGeoExcludesItem]
    ] = UNSET
    includes: Union[
        Unset, List[SearchService_SearchJsonBodyCriteriaGeoIncludesItem]
    ] = UNSET
    additional_properties: Dict[str, Any] = attr.ib(init=False, factory=dict)

    def to_dict(self) -> Dict[str, Any]:
        excludes: Union[Unset, List[Any]] = UNSET
        if not isinstance(self.excludes, Unset):
            excludes = []
            for excludes_item_data in self.excludes:
                excludes_item = excludes_item_data.to_dict()

                excludes.append(excludes_item)

        includes: Union[Unset, List[Any]] = UNSET
        if not isinstance(self.includes, Unset):
            includes = []
            for includes_item_data in self.includes:
                includes_item = includes_item_data.to_dict()

                includes.append(includes_item)

        field_dict: Dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update({})
        if excludes is not UNSET:
            field_dict["excludes"] = excludes
        if includes is not UNSET:
            field_dict["includes"] = includes

        return field_dict

    @classmethod
    def from_dict(cls: Type[T], src_dict: Dict[str, Any]) -> T:
        d = src_dict.copy()
        excludes = []
        _excludes = d.pop("excludes", UNSET)
        for excludes_item_data in _excludes or []:
            excludes_item = (
                SearchService_SearchJsonBodyCriteriaGeoExcludesItem.from_dict(
                    excludes_item_data
                )
            )

            excludes.append(excludes_item)

        includes = []
        _includes = d.pop("includes", UNSET)
        for includes_item_data in _includes or []:
            includes_item = (
                SearchService_SearchJsonBodyCriteriaGeoIncludesItem.from_dict(
                    includes_item_data
                )
            )

            includes.append(includes_item)

        search_service_search_json_body_criteria_geo = cls(
            excludes=excludes,
            includes=includes,
        )

        search_service_search_json_body_criteria_geo.additional_properties = d
        return search_service_search_json_body_criteria_geo

    @property
    def additional_keys(self) -> List[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
