from typing import Any, Dict, List, Type, TypeVar, Union

import attr

from ..types import UNSET, Unset

T = TypeVar("T", bound="Servicer")


@attr.s(auto_attribs=True)
class Servicer:
    """ Pool Allocation of Remaining Principal Balance """

    loans: Union[Unset, int] = UNSET
    name: Union[Unset, str] = UNSET
    percentage_rpb: Union[Unset, float] = UNSET
    rpb: Union[Unset, float] = UNSET
    additional_properties: Dict[str, Any] = attr.ib(init=False, factory=dict)

    def to_dict(self) -> Dict[str, Any]:
        loans = self.loans
        name = self.name
        percentage_rpb = self.percentage_rpb
        rpb = self.rpb

        field_dict: Dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update({})
        if loans is not UNSET:
            field_dict["loans"] = loans
        if name is not UNSET:
            field_dict["name"] = name
        if percentage_rpb is not UNSET:
            field_dict["percentageRpb"] = percentage_rpb
        if rpb is not UNSET:
            field_dict["rpb"] = rpb

        return field_dict

    @classmethod
    def from_dict(cls: Type[T], src_dict: Dict[str, Any]) -> T:
        d = src_dict.copy()
        loans = d.pop("loans", UNSET)

        name = d.pop("name", UNSET)

        percentage_rpb = d.pop("percentageRpb", UNSET)

        rpb = d.pop("rpb", UNSET)

        servicer = cls(
            loans=loans,
            name=name,
            percentage_rpb=percentage_rpb,
            rpb=rpb,
        )

        servicer.additional_properties = d
        return servicer

    @property
    def additional_keys(self) -> List[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
