from typing import Any, Dict, List, Optional, Union

import attr

import infima_client.api.search_service.search_service_search as search_service_search
from infima_client.models import *

from .client import Client
from .types import UNSET, Response, Unset
from .util import named_arguments_only


class search:
    def __init__(self, client: Client):
        self.client = client
        self._detailed = searchDetailed(client)

    @named_arguments_only
    def search(
        self, json_body: SearchService_SearchJsonBody
    ) -> Optional[
        Union[Search, SearchBadRequest, SearchUnauthorized, SearchNotFound, SearchError]
    ]:

        """
        Search for pools within a cohort universe.

        Args:

        Returns:
            Either a valid response or an unauthorized, not found or other error.
        """

        return search_service_search.sync(client=self.client, json_body=json_body)


class searchDetailed:
    def __init__(self, client: Client):
        self.client = client

    @named_arguments_only
    def search(
        self, json_body: SearchService_SearchJsonBody
    ) -> Response[
        Union[Search, SearchBadRequest, SearchUnauthorized, SearchNotFound, SearchError]
    ]:

        return search_service_search.sync_detailed(
            client=self.client, json_body=json_body
        )
